﻿using System;
using System.Net;
using System.Net.Sockets;
using System.IO;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace ClientUdp
{
    class ClientUdp
    {

        static void readNet(Socket client,EndPoint server)
        {
            try
            {

                byte[] buffer = new byte[1500];
                while (true)
                {
                    int nBytes = client.ReceiveFrom(buffer, buffer.Length, SocketFlags.None, ref server);
                    ChatMessage receive = new ChatMessage(buffer);
                    if (receive.commandeType == CommandeType.REPONSE)
                    {
                        Console.WriteLine(" <Reponse du serveur> " + receive.data);
                    }
                    else
                    {
                        string[] splitted = receive.data.Split('\0');
                        Console.WriteLine(" <" + splitted[0] + "> " + splitted[1]);
                    }
                }
            }
            catch(Exception e)
            {
                Console.WriteLine("ERROR READ NET : Serveur fermé");
            }
            
        }
        static void Main(string[] args)
        {
            Console.WriteLine("Port(pas 11111)?");
            int portClient = Convert.ToInt32(Console.ReadLine());
            Console.WriteLine('\n' + "Pseudo?");
            string pseudo = Console.ReadLine();

            try
            {

                //************************************************************** Initialisation

                Console.WriteLine("=============================================");
                Console.WriteLine("=============================================");
                Console.WriteLine("================== CLIENT ===================");
                Console.WriteLine("=============================================");
                Console.WriteLine("=============================================" + '\n' + '\n');

                string serverIP = "127.0.0.1";    // A changer
                int serverPort = 11111 ;       // A changer


                // Création de la socket d'écoute UDP
                Socket clientSocket = new Socket(
                    AddressFamily.InterNetwork,
                    SocketType.Dgram,
                    ProtocolType.Udp);


                // Liaison de la socket au point de communication
                clientSocket.Bind(new IPEndPoint(IPAddress.Any, portClient));


                // Création du EndPoint serveur
                EndPoint serverEP = new IPEndPoint(IPAddress.Parse(serverIP), serverPort);

                Thread sendAll = new Thread(x => readNet(clientSocket, serverEP));
                sendAll.Start();

                bool loop = true;
                while (loop)
                {
                    Console.WriteLine('\n' + "Commande? (Help: 2)");
                    int cmd = Convert.ToInt32(Console.ReadLine());

                    if (cmd == 3) // QUIT
                        loop = false;

                    string dat = "";
                    if (cmd == 0) // POST
                    {
                        Console.WriteLine('\n' + "Message?");
                        dat = Console.ReadLine();
                    }

                    // Lecture message au clavier
                    ChatMessage m;
                    if(cmd == 0)
                        m = new ChatMessage((Commande)cmd, CommandeType.REQUETE, pseudo + '\0' +dat);
                    else
                        m = new ChatMessage((Commande)cmd, CommandeType.REQUETE, dat);



                    //************************************************************** Communications

                    // Encodage du string dans un buffer de bytes en ASCII
                    byte[] buffer = m.GetBytes();

                    // Envoie du message au serveur
                    int nBytes = clientSocket.SendTo(buffer, 0, buffer.Length, SocketFlags.None, serverEP);

                    Thread.Sleep(100);
                }
                //************************************************************** Conclusion
                // Fermeture socket
                Console.WriteLine("Fermeture Socket...");
                clientSocket.Close();

                Thread.Sleep(500);
                Environment.Exit(0);
            }
            catch (SocketException E)
            {
                Console.WriteLine(E.Message);
                Console.ReadKey();
            }

            Console.ReadKey();
        }
    }
}
